%% BOUNDING PHASE METHOD %%
%% Developed by Dr. Rajib Kuamr Bhattacharjya %%
%% Department of Civil Engineering, IIT Guwahati %%
%% This method is used to bracket the optiam of a minimization function
%% xo is the starting points, del is the increment in x 
%% funcName is the name of the function 
%% x1 and x2 are the bracket
%% k is the number of iteration required to bracket the optima
%% An example function 'func' has been provided
%% For bracketing minima of the function just excecute the BoundingPhase
%% function using "[x1 x3 k]=BoundingPhase(0,0.001, 'func')" Where x0=0,
%% del=0.001 and funcName='func'
function [x1 x3 k]=BoundingPhase(x0,del, funcName)

x1=x0-del;
x2=x0;
x3=x0+del;

fx1=feval(funcName,x1);
fx2=feval(funcName,x2);
fx3=feval(funcName,x3);
% fx2=func(x2);
% fx3=func(x3);

if(fx1>=fx2 & fx2>=fx3)
    del=del;
else
    del=-del;
end
k=1;
x(k)=x0+2^k*del;
fx0=fx2;
fx1=feval(funcName,x(k));
while(fx1<fx0)
        k=k+1;
        fx0=fx1;
        x(k)=x(k-1)+2^k*del;
        fx1=feval(funcName, x(k));
end

x1=x(k-2);
x3=x(k);
